//---------------------------------------------------------------------------
//  MIME(Quoted-Printable & Base64) Encode/Decode unit. (PAS)
//  Copyright (c) 2000, 01 Mental Studio - http://msrc.126.com
//  Author : Raptor - raptorz@163.com
//---------------------------------------------------------------------------
Unit MimeQPB64;

Interface

Uses
    Classes, SysUtils;

Type
    TMimeType = ( mtNone, mtQP, mtBase64, mtUnknown );
    PByte = ^Byte;

Function  MimeEncode( aSrc : TMemoryStream; aType : TMimeType ) : String; Overload;
Function  MimeEncode( aSrc : String;        aType : TMimeType ) : String; Overload;
Procedure MimeDecode( aDest : TMemoryStream; aSrc : String; aType : TMimeType );

Implementation

{$L mimeb64d.obj}

Function QPEncode(     aDest : PChar; aSrc : PByte; aLen : Integer ) : Integer; External;
Function QPDecode(     aDest : PByte; aSrc : PChar                 ) : Integer; External;
Function Base64Encode( aDest : PChar; aSrc : PByte; aLen : Integer ) : Integer; External;
Function Base64Decode( aDest : PByte; aSrc : PChar                 ) : Integer; External;

//  ΪDELPHIstring.hеĺҪдô
Function _strlen( aStr : PChar ) : Integer; cdecl;
Begin
	Result := Length( aStr );
End;

//  Ϊ MIME ַ
//  aSrc ΪԴ aType Ϊ MIME 
//  ؽַ
Function MimeEncode( aSrc : TMemoryStream; aType : TMimeType ) : String;
Var
    buf : TMemoryStream;
Begin
    buf := TMemoryStream.Create;
    Try
        If ( aType = mtQP ) Then           //  QPEncode
        Begin
        	buf.Size := aSrc.Size * 3 + 1;
            QPEncode( PChar( buf.Memory ), PByte( aSrc.Memory ), aSrc.Size );
        End
        Else If ( aType = mtBase64 ) Then  //  Base64Encode
        Begin
        	buf.Size := aSrc.Size * 4 DIV 3 + 1;
            Base64Encode( PChar( buf.Memory ), PByte( aSrc.Memory ), aSrc.Size );
        End
        Else
        	Raise Exception.Create( 'Invalid MIME type!' );
        Result := PChar( buf.Memory );
    Finally
        buf.Free;
    End;
End;

//  ַΪ MIME ַ
//  aSrc ΪԴַ aType Ϊ MIME 
//  ؽַ
Function MimeEncode( aSrc : String; aType : TMimeType ) : String;
Var
    buf : TMemoryStream;
Begin
    buf := TMemoryStream.Create;
    Try
        If ( aType = mtQP ) Then           //  QPEncode
        Begin
        	buf.Size := Length( aSrc ) * 3 + 1;
            QPEncode( PChar( buf.Memory ), PByte( PChar( aSrc ) ), Length( aSrc ) );
        End
        Else If ( aType = mtBase64 ) Then  //  Base64Encode
        Begin
        	buf.Size := Length( aSrc ) * 4 DIV 3 + 1;
            Base64Encode( PChar( buf.Memory ), PByte( PChar( aSrc ) ), Length( aSrc ) );
        End
        Else
        	Raise Exception.Create( 'Invalid MIME type!' );
        Result := PChar( buf.Memory );
    Finally
        buf.Free;
    End;
End;

//  ַн MIME 
//  aDest Ϊ aSrc ΪԴַ aType Ϊ MIME 
Procedure MimeDecode( aDest : TMemoryStream; aSrc : String; aType : TMimeType );
Begin
    aDest.Size := Length( aSrc ) + 1;
    If ( aType = mtQP ) Then           //  QPDecode
        aDest.Size := QPDecode( PByte( aDest.Memory ), PChar( aSrc ) )
    Else If ( aType = mtBase64 ) Then  //  Base64Decode
        aDest.Size := Base64Decode( PByte( aDest.Memory ), PChar( aSrc ) )
    Else
        Raise Exception.Create( 'Invalid MIME type!' );
End;

End.

